#!/usr/bin/python
# -*- coding: latin-1 -*-
#
# (c) 2018 Microchip Technology Inc.Ǝq
#
# ̏̏ƂāAMicrochipĳƉ̔hMicrochipi
# ɌĎgp邱Ƃł܂BMicrochipĳ𔺂Ȃ(J 
# ĳ܂)Oҿĳ̎gpɓKpO҂̋炷̂͂
# ̐ӔCłB
#
# ̿ĳMicrochip"󂻂̂܂"ɂċ܂BNQAiA
# ړIւ̓K̂ǂ̈Öق̕ۏ؂܂߁AIAÎI܂͖@߂ł낤
# ̿ĳɂ͓Kp܂BႦMicrochip\iꂽAQ\
# ƂĂA̔@Ɋւ炸A@ȂꍇłMicrochipͿĳɊ֘A
# @Ȃނ̊ԐړIAʁAIAI܂͕KRIȑAQAp
# ͎x̐ӔC𕉂܂B@ɂċő͈̔͂܂ŁA̿ĳ
# Ɋ֘Aǂ̕@ł̑SɉĂAmicrochip̑ӔCźA΁A
# Ȃ̿ĳɑ΂Microchip֒ڎxp̊z𒴂܂B

# Microchip tinyAVR 01nymegaAVR 0nMCUpް۰ 
#
# Python 23x悤ɏ
# https://www.python.org/downloads/Python޳۰ނĂB
#
from __future__ import print_function
try:
	import sys
	from builtins import bytes, int
	import argparse
	from serial import Serial
	from intelhex import IntelHex
except ImportError:
    sys.exit("""ImportError: You are probably missing some modules.
To add needed modules, run 'python -m pip install -U future pyserial intelhex'""")

# 菕Ǝgүނ𐶐
parser = argparse.ArgumentParser(
description='Serial bootloader script for Microchip tinyAVR 0-, 1-series and megaAVR 0-series MCUs',
epilog='Example: tiny_uploader.py ./App/Release/App.hex 0x2000 COM130 115200',
formatter_class=argparse.RawTextHelpFormatter)
parser.add_argument('file', help='Hex file to upload')
parser.add_argument('flashsize', help='Total device flash size')
parser.add_argument('comport', help='UART COM port')
parser.add_argument('baudrate', help='UART baud rate')
if len(sys.argv)==1:
    parser.print_help()
    sys.exit(1)
args = parser.parse_args()

# ލs
file = sys.argv[1]
flashsize = int(sys.argv[2], 0)
comport = sys.argv[3]
baudrate = int(sys.argv[4], 0)

# p̧ٓǂݍ݂޲Ĕzɕϊ
# hex̧قBOOTEND~256ɑΉJnڽȂ΂Ȃ܂B
# z͉p/pް̈Ŝ𖞂߂$FFŌ߂܂B
ih = IntelHex()
fileextension = file[-3:]
ih.loadfile(file, format=fileextension)
append = ih.maxaddr()
if (append > flashsize):
    print ("Error: Flashsize input: %#06x, " % (flashsize) +
           "Minimum size needed: %#06x." % (append))
    sys.exit(1)
appstart = ih.minaddr()
app = ih.tobinarray(end=flashsize-1)


# ʐM
uart = Serial(comport, baudrate=baudrate, timeout=1)

# p޲֑oBe޲Ă͊mF̂߂ɑԂ܂B
size = len(app)
failed = 0
counter = 0

print ("Uploading", size, "bytes...")
for byte in app:
    byte = bytes([byte])
    uart.write(byte)
    tmp_byte = uart.read(1)
    if (tmp_byte != byte):
        failed = 1
        break
    counter += 1
    print ("\r%.02f%%" % (float(counter)/size*100), end='')

# JԂoR𒲂ׂޯޏ\
if failed:
    print ("\nFailed at address %#06x" % (counter+appstart))
    tmp_byte = int.from_bytes(tmp_byte, byteorder="little")
    byte = int.from_bytes(byte, byteorder="little")
    print ("Value %#04x echoed, expected %#04x" % (tmp_byte, byte))
else:
    print ("\nOK")

# ޲ׯɏꂽؾĂĉp֔т܂B
# ͂܂͊OIؾĂdOFF/ON邱Ƃł܂B